#include <iostream>
using namespace std;

const int MAX_SECTIONS = 180;
const int MOD = 1234567;
const int MAX_M = 7;

typedef long long matrix[MAX_SECTIONS][MAX_SECTIONS];

int m, m2, m3, n, sectcnt;
int sect[MAX_SECTIONS][MAX_M];
matrix d;

void gensections()
{
    for(int i=0; i<m3; i++)
    {
        int x = i;
        int zerocnt = 0;
        for(int j=0; j<m; j++)
        {
            sect[sectcnt][j] = x%3;
            if(sect[sectcnt][j]==0) zerocnt++;
            x/=3;
        }
        int cnt01=0;
        for(int j=0; j<m-1; j++)
            if(sect[sectcnt][j] + sect[sectcnt][j+1] == 1) cnt01++;
        if(zerocnt && cnt01 == 0) sectcnt++;
    }
} 

long long can(int p1, int p2)
{
    int k;
    for(int j=0; j<m; j++)
    {
        if(sect[p2][j]==1)
        {
            if(sect[p1][j]==0) return 0;
            k = j + 1;
            while (k < m && sect[p2][k]==1)
            {
                if(sect[p1][k] == 0) return 0;
                k++;
            }
            k = j - 1;
            while (k>=0 && sect[p2][k]==1)
            {
                if(sect[p1][k] == 0) return 0;
                k--;
            }
        }
        
        if(sect[p2][j]==0)
        {
            bool is_ok = false;
            if(sect[p1][j]==0)
                is_ok = true;
            k = j + 1;
            while(k < m && !is_ok && sect[p2][k]==0)
            {
                if(sect[p1][k]==0) is_ok=true;
                k++;
            }
            k = j -1;
            while(k>=0 && !is_ok && sect[p2][k] == 0)
            {
                if(sect[p1][k]==0) is_ok=true;
                k--;
            }
            if (!is_ok) return 0;
        }
    }
    return 1;
}

void mult(matrix a, matrix b)
{
  matrix c;
  for(int i=0; i<sectcnt; i++)
    for(int j=0; j<sectcnt; j++)
    {
      c[i][j]=0;
      for(int t = 0; t<sectcnt; t++)
        c[i][j] = (c[i][j] +  a[i][t]*b[t][j]) % MOD;
    }
  for(int i=0; i<sectcnt; i++)
    for(int j=0; j<sectcnt; j++)
      a[i][j]=c[i][j];
}

void power(matrix a, long long k)
{
  matrix ans;
  for(int i=0; i<sectcnt; i++)
    for(int j=0; j<sectcnt; j++)
      if(i==j) ans[i][j]=1;
      else ans[i][j]=0;
  while(k)
  {
    if (k&1) mult(ans,a);
      mult(a,a);
      k >>= 1;
  }
  for(int i=0; i<sectcnt; i++)
    for(int j=0; j<sectcnt; j++)
      a[i][j]=ans[i][j];
}

void determine_D()
{
    for(int i=0; i<sectcnt; i++)
      for(int j=0; j<sectcnt; j++)
        d[i][j]= can(i,j);
}

int main()
{
  long long n;
  cin >> m >> n;
  m-=2;
  m3 = 1;
  for(int i=0; i<m; i++) m3*=3;
  gensections();
  determine_D();
  power(d,n-1);
  long long ans=0;
  for(int i=0; i<sectcnt; i++)
  {
      bool is_ok=true;
      for(int j=0; j<m; j++)
        if(sect[i][j]==1) {is_ok = false; break;}
      if(is_ok)
        for(int j=0; j<sectcnt; j++)
            ans += d[i][j];
  }
  cout << ans % MOD << '\n'; 
  return 0;
}
